<?php


namespace Teknisa\ACL\Services;

use Teknisa\ACL\Util\InstanceProvider;
use Teknisa\ACL\Util\AclUtilities;
use Teknisa\ACL\Util\Messages;
use Teknisa\ACL\Repositories\Crud;
use Teknisa\Libs\Util\Utilities as LibUtilities;
use Zeedhi\Framework\Remote\FileUploader\Server;

class SqlLogs{

    const ARRAY_FIELD_SL = array("PARSING_SCHEMA_NAME", "MODULE", "ACTION", "ELAPSED_TIME", "SQL_FULLTEXT", "LAST_ACTIVE_TIME", "FIRST_LOAD_TIME");

    public function findSqlLogs($conditions, $pageSize, $page, $orderBy){
        $sqlLogsRepository = InstanceProvider::getRepository()->getSqlLogsRepository();
        $limit = $page * $pageSize;
        $offset = ($page - 1) * $pageSize;
        $orderByString = '';
        foreach($orderBy as $idx => $order) {
            if (AclUtilities::validadeOrder($idx, $order, self::ARRAY_FIELD_SL)) {
                $orderByString .= ' ORDER BY ' . $idx . ' ' . $order;
            }
        }


        list($filters, $bindParams, $typeBindParams) = AclUtilities::createQueryFilteredAndBind($conditions, null,self::ARRAY_FIELD_SL);
        return  $sqlLogsRepository->findSqlLogs($filters, $limit, $offset, $bindParams, $typeBindParams, $orderByString);
    }

    public function findDbUser(){
        $sqlLogsRepository = InstanceProvider::getRepository()->getSqlLogsRepository();

        return $sqlLogsRepository->findDbUser();
    }
}